// testet private copyprivate firstprivate lastprivate

#include "stdafx.h"
#include <omp.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

// private
void test1() {
	int i,j, k;
	i=1;
	j=2;
	k=3;

	// private:	
	// Wert in der Schleife unbestimmt,                       Absturz	
	#pragma omp parallel private(i,j)
	{
		i=42;
		k++;
		j=0;  // auskommentieren
		int id = omp_get_thread_num();
		printf("Thread %d  lokales i: %d  lokales j: %d   k:%d\n",id, i, j, k );
		i+=id;
		j+=id;	
	}

	printf("Nach private Loop i: %d  j: %d\n", i, j);
	printf("\n\n");
}


// firstprivate:	
// Der Wert der Variablen in der Schleife wird aus der Variablen vor der Schleife "kopiert"
void test2() {
	int i,j, k;
	i=1;
	j=2;
	k=3;
	#pragma omp parallel private(i)  firstprivate(j) 
	{
		i=42;
		int id = omp_get_thread_num();
		printf("a) Thread %d  lokales i: %d  lokales j: %d\n",id, i, j );
		i+=id+1;
		j+=id+1;	
		printf("b) Thread %d  lokales i: %d  lokales j: %d\n",id, i, j );
	}

	printf("Nach firstprivate Loop i: %d  j: %d\n", i, j);
	printf("\n\n");
}


// lastprivate:	
// der letzte Wert in der Schleife, letzter Index, wird der Variablen im Block zugewiesen
void test3() {
	int i,j;
	i=-1;
	j=-2;
	int n=10;
	// lastprivate(i)
	
	#pragma omp parallel for private(i) lastprivate(j)
		for (i=0; i<n; i++) {			
			srand ( time(NULL) );
			if (i==0) {
				for (int jj=0; jj<10000000; jj++) {
					double d=sin(34.0);
				}
			}
			j=i+1;
			printf("i %d\n", i);
		}
	printf("Nach lastprivate Loop i: %d  j: %d\n", i, j);
	printf("\n\n");
}



// threadprivate
/*
Diese Variablen sind global, die im parallelen Programmabschnitt !!!!
jedoch als privat behandelt werden und als Wert uebergeben
              Der globale Wert wird aber ber den parallelen Abschnitt hinweg bewahrt.  !!!
              Man hat also drei Schleifen, die threadprivate-Variablen bleiben im Wert vorhanden

also firstprivate und lastprivate mit globaler Variable
*/
int G_ThreadPrivate_id, G_ThreadPrivate_sum;
#pragma omp threadprivate(G_ThreadPrivate_id, G_ThreadPrivate_sum)

void test4() {
	int k=42, tid;	
	int n=10;		
	G_ThreadPrivate_id=1000;
	G_ThreadPrivate_sum=0;
	printf("Vor threadprivate Loop G_ThreadPrivate_id: %d   G_ThreadPrivate_sum:%d\n\n", G_ThreadPrivate_id, G_ThreadPrivate_sum);
	omp_set_num_threads(4);
	
	omp_set_dynamic(0);
	// keine Aufteilung der Indizes, jeder "Thread" wird nur einmal ausgefhrt
	// jeder bekommt die Werte  la firstprivate
	// nur der 1. Thread setzt die Werte nach aussen
	#pragma omp parallel private(k, tid)
	{
		tid = omp_get_thread_num();        
		k = G_ThreadPrivate_id;
		G_ThreadPrivate_id=tid;
		G_ThreadPrivate_sum+=(tid+1);
		printf("In Loop:  tid:%d   G_ThreadPrivate_id(alt):%d   \n       G_ThreadPrivate_id: %d   G_ThreadPrivate_sum:%d\n", tid, k, G_ThreadPrivate_id, G_ThreadPrivate_sum);
	}
	printf("Nach threadprivate Loop G_ThreadPrivate_id: %d   G_ThreadPrivate_sum:%d\n", G_ThreadPrivate_id, G_ThreadPrivate_sum); // 0 und 1
	printf("\n\n");
	#pragma omp parallel private(k, tid)
	{		
		tid = omp_get_thread_num();
		// hier sind die Werte aus der ersten Schleife noch vorhanden
		printf("In Loop:  tid:%d   G_ThreadPrivate_id: %d G_ThreadPrivate_sum:%d\n", tid, G_ThreadPrivate_id, G_ThreadPrivate_sum);
	}

   //	static  dynamic  guided  runtime

   #pragma omp parallel for schedule(dynamic,1)  private(k, tid)
	  for (int i=0; i<1000000; i++) {
         if (G_ThreadPrivate_id==2) {
				for (int jj=0; jj<10000; jj++) {
					double d=sin(34.0);
				}
			}
		 else {
				for (int jj=0; jj<100; jj++) {
					double d=sin(34.0);
				}
		 }
		G_ThreadPrivate_sum++;
	  }	

	printf("Nach threadprivate Loop G_ThreadPrivate_id: %d  G_ThreadPrivate_sum:%d\n", G_ThreadPrivate_id, G_ThreadPrivate_sum);
	printf("\n\n");
	#pragma omp parallel private(k, tid)
	{		
		tid = omp_get_thread_num();
		printf("In Loop:  tid:%d   G_ThreadPrivate_id: %d G_ThreadPrivate_sum:%d\n", tid, G_ThreadPrivate_id, G_ThreadPrivate_sum);
	}

	printf("Nach threadprivate Loop G_ThreadPrivate_id: %d   G_ThreadPrivate_sum:%d\n", G_ThreadPrivate_id, G_ThreadPrivate_sum);
	printf("\n\n");
}  // test4




// copyprivate:	der zugewiesene Wert wird allen zugestellt BCast
void test5() {	
	float a, b, x, y;
	a=-1;
	b=-2;
	x=-3;
	y=-4;
	#pragma omp parallel private(a,b, x,y) 
	{
		  // nur einer durchlaueft diesen Teil, egal welcher (z. B. Master)
		#pragma omp single copyprivate(a,b) 
		{
			puts("x");
			// lesen aus Datei etc.
			a=2;
			b=3;
			int id = omp_get_thread_num();
			printf("Init durch Thread  %d   a:%f  b:%f\n", id,a,b);
		}		
		int id = omp_get_thread_num();
		x=(float)id;
		y=a+ b*x;
		printf("Thread-Id %d  a: %f  b: %f x: %f  y: %f\n", id, a, b , x, y  );

	}
}


// copyin
/*
copyin ist analog zu firstprivate fr private Daten, 
allerdings nicht fr threadprivate Daten, welche nicht initialisiert werden. 
Mit copyin wird der globale Wert explizit an die privaten Daten bertragen. 
Ein copyout ist nicht notwendig, da der globale Wert bewahrt wird.

Ermglicht Threads, um den Wert des Masterthreads, fr eine threadprivate-Variable zuzugreifen.
In der ersten Schleife hat jeder Thread den Originalwert
  Der naechste Thread in der ersten Schleife hat den VORHERIGEN Wert
In den nchsten Schleifen hat jeder Thread den Wert des Master-Threads
*/

int G_ThreadPrivate_k;
#pragma omp threadprivate(G_ThreadPrivate_k)

void test6() {
	int i,k;
	i=-1;	
	int n=10;
	G_ThreadPrivate_k=1001;

    printf("Vor copyin Loop G_ThreadPrivate_k: %d\n", G_ThreadPrivate_k);

	// copyin(G_ThreadPrivate_k)
	#pragma omp parallel for copyin(G_ThreadPrivate_k) private(i,k)
		for (i=0; i<n-1; i++) {
			k=G_ThreadPrivate_k; // jeder erhaelt den Originalwert
			G_ThreadPrivate_k=i; // jeder setzt den Wert auf ID
			printf("In Loop:  i:%d   G_ThreadPrivate_k(alt):%d  G_ThreadPrivate_k: %d\n", i, k, G_ThreadPrivate_k);
		}
	printf("Nach threadprivate Loop G_ThreadPrivate_k: %d\n\n\n", G_ThreadPrivate_k);  // Ergebnis 2

	#pragma omp parallel for copyin(G_ThreadPrivate_k) private(i,k)
		for (i=0; i<n-1; i++) {
			k=G_ThreadPrivate_k; // jeder erhaelt den Originalwert
			G_ThreadPrivate_k=(i+1)*100; // jeder setzt den Wert auf ID
			printf("In Loop2:  i:%d   G_ThreadPrivate_k(alt):%d  G_ThreadPrivate_k: %d\n", i, k, G_ThreadPrivate_k);
		}
	printf("Nach threadprivate Loop2 G_ThreadPrivate_k: %d\n\n\n", G_ThreadPrivate_k);  // Ergebnis 2

	#pragma omp parallel for copyin(G_ThreadPrivate_k) private(i,k)
		for (i=0; i<n-1; i++) {
			k=G_ThreadPrivate_k; // jeder erhaelt den Originalwert
			//G_ThreadPrivate_k=i; // jeder setzt den Wert auf ID
			printf("In Loop3:  i:%d   G_ThreadPrivate_k(alt):%d  G_ThreadPrivate_k: %d\n", i, k, G_ThreadPrivate_k);
		}

	printf("Nach threadprivate Loop3 G_ThreadPrivate_k: %d\n", G_ThreadPrivate_k);
	printf("\n\n");
}
/*
	Vor den Methoden
	Max Threads: 4   Anzahl CPU: 4

	Vor copyin Loop G_ThreadPrivate_k: 1001
	In Loop:  i:3   G_ThreadPrivate_k(alt):1001  G_ThreadPrivate_k: 3		Alter Wert ist 1001		Neuer Wert ist 3
	In Loop:  i:4   G_ThreadPrivate_k(alt):3  G_ThreadPrivate_k: 4			Alter Wert ist 3		Neuer Wert ist 4
	In Loop:  i:5   G_ThreadPrivate_k(alt):1001  G_ThreadPrivate_k: 5		Alter Wert ist 4		Neuer Wert ist 5
	In Loop:  i:6   G_ThreadPrivate_k(alt):5  G_ThreadPrivate_k: 6
	In Loop:  i:7   G_ThreadPrivate_k(alt):1001  G_ThreadPrivate_k: 7
	In Loop:  i:8   G_ThreadPrivate_k(alt):7  G_ThreadPrivate_k: 8
	In Loop:  i:0   G_ThreadPrivate_k(alt):1001  G_ThreadPrivate_k: 0
	In Loop:  i:1   G_ThreadPrivate_k(alt):0  G_ThreadPrivate_k: 1
	In Loop:  i:2   G_ThreadPrivate_k(alt):1  G_ThreadPrivate_k: 2
	Nach threadprivate Loop G_ThreadPrivate_k: 2							Letzte Zuweisung


	In Loop2:  i:3   G_ThreadPrivate_k(alt):2  G_ThreadPrivate_k: 400
	In Loop2:  i:4   G_ThreadPrivate_k(alt):400  G_ThreadPrivate_k: 500
	In Loop2:  i:7   G_ThreadPrivate_k(alt):2  G_ThreadPrivate_k: 800
	In Loop2:  i:8   G_ThreadPrivate_k(alt):800  G_ThreadPrivate_k: 900
	In Loop2:  i:5   G_ThreadPrivate_k(alt):2  G_ThreadPrivate_k: 600
	In Loop2:  i:6   G_ThreadPrivate_k(alt):600  G_ThreadPrivate_k: 700
	In Loop2:  i:0   G_ThreadPrivate_k(alt):2  G_ThreadPrivate_k: 100
	In Loop2:  i:1   G_ThreadPrivate_k(alt):100  G_ThreadPrivate_k: 200
	In Loop2:  i:2   G_ThreadPrivate_k(alt):200  G_ThreadPrivate_k: 300
	Nach threadprivate Loop2 G_ThreadPrivate_k: 300							Letzte Zuweisung


	In Loop3:  i:3   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:4   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:5   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:6   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:7   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:8   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:0   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:1   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	In Loop3:  i:2   G_ThreadPrivate_k(alt):300  G_ThreadPrivate_k: 300
	Nach threadprivate Loop3 G_ThreadPrivate_k: 300
*/



int _tmain(int argc, _TCHAR* argv[])
{
	omp_set_num_threads(4);
	puts("Vor den Methoden");
	printf("Max Threads: %d   Anzahl CPU: %d\n\n", omp_get_max_threads(), omp_get_num_procs() );

	//test1();  // private
	//test2();  // firstprivate
	// test3();  // lastprivate
	 test4();  // threadprivate, Variablen sind in mehreren Schleifen gueltig
	//test5();  // copyprivate
	//test6();


     // ----------------------------------------------------------------


	
	return 0;
}




